<?php
/*
  webfinanz.php, copy from:
  $Id: moneyorder.php,v 1.10 2003/01/29 19:57:14 hpdl Exp $
  ShopNix 2007-12-27 for Santander Webfinanz

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/

  class webfinanz {
    var $code, $title, $description, $enabled, $santander_uri;

// class constructor
    function webfinanz() {
      global $order;

      $this->code = 'webfinanz';
      $this->title = MODULE_PAYMENT_WEBFINANZ_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_WEBFINANZ_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_WEBFINANZ_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_WEBFINANZ_STATUS == 'True') ? true : false);
      $this->santander_uri = 'https://shop.santander.de/webfinanz/deutsch/startWebfinanz.jsp?haendlernummer=';

      if ((int)MODULE_PAYMENT_WEBFINANZ_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_WEBFINANZ_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();

      $this->email_footer = MODULE_PAYMENT_WEBFINANZ_TEXT_EMAIL_FOOTER;
    }

// class methods
    function update_status() {
      global $order;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_WEBFINANZ_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_WEBFINANZ_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
      if ($this->enabled == true) {
        if ($order->info['total'] <= (float)MODULE_PAYMENT_WEBFINANZ_MIN_BETRAG) {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->title);
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      return array('title' => MODULE_PAYMENT_WEBFINANZ_TEXT_DESCRIPTION);
    }

    function process_button() {
      return false;
    }

    function before_process() {
      return false;
    }

    function after_process() {
      global $order, $insert_id, $cart;

//      dbgInfo($insert_id, __FILE__, __LINE__);

      if (isset($this->santander_uri)) {
        $this->santander_uri .= trim(MODULE_PAYMENT_WEBFINANZ_HAENDLERNUMMER);
        $this->santander_uri .= '&kaufpreis=' . trim($order->info['total']);
        $this->santander_uri .= '&warenbezeichnung=' . trim(MODULE_PAYMENT_WEBFINANZ_WARENBEZEICHNUNG);
        $this->santander_uri .= '-' . $insert_id;

// from checkout_process.php
// unregister session variables used during checkout
        tep_session_unregister('sendto');
        tep_session_unregister('billto');
        tep_session_unregister('shipping');
        tep_session_unregister('payment');
        tep_session_unregister('comments');

$cart->reset(true);
// end checkout_process

        tep_redirect($this->santander_uri);
       }
      return false;
    }

    function get_error() {
      return false;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_WEBFINANZ_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Check/Money Order Module', 'MODULE_PAYMENT_WEBFINANZ_STATUS', 'True', 'Do you want to accept Check/Money Order payments?', '6', '0', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now());");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_WEBFINANZ_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_WEBFINANZ_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '2', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_WEBFINANZ_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('H&auml;ndlernummer:', 'MODULE_PAYMENT_WEBFINANZ_HAENDLERNUMMER', '', 'Santander Webfinanz H&auml;ndlernummer', '6', '5', now());");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Warenbezeichnung:', 'MODULE_PAYMENT_WEBFINANZ_WARENBEZEICHNUNG', '', 'Bezeichnung der Ware, bitte ohne Umlaute und Sonderzeichen!', '6', '5', now());");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Mindestbetrag:', 'MODULE_PAYMENT_WEBFINANZ_MIN_BETRAG', '', 'Mindestbetrag, fr den diese Zahlungsmethode angeboten werden soll.', '6', '5', now());");

    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_WEBFINANZ_STATUS', 'MODULE_PAYMENT_WEBFINANZ_ZONE', 'MODULE_PAYMENT_WEBFINANZ_ORDER_STATUS_ID', 'MODULE_PAYMENT_WEBFINANZ_SORT_ORDER',  'MODULE_PAYMENT_WEBFINANZ_HAENDLERNUMMER', 'MODULE_PAYMENT_WEBFINANZ_WARENBEZEICHNUNG', 'MODULE_PAYMENT_WEBFINANZ_MIN_BETRAG');
    }
  }
?>
